<?php
/* Forum - forum_details.php
 - Webbausteine.de */

// Session starten
session_start();

include "forum_verbindung.php";

// Thread überprüfen
if (isset($_GET["thread"]) &&
    ctype_digit($_GET["thread"]) &&
    strlen($_GET["thread"]) == 19) {
 $thread = $_GET["thread"];

 // Anzahl der Seiten berechnen
 $kommando = $VERBINDUNG->prepare("SELECT `thema`, `sperre`
                                                           FROM `" . $TABLE_PREFIX . "_forum`
                                                           WHERE `thread` = :thread AND `anzeige` = '1'");
 $kommando->bindParam(':thread', $thread);
 $kommando->execute();
 $thema = $kommando->fetchAll(PDO::FETCH_OBJ);
 $anzahlThemen = count($thema);

 if ($anzahlThemen > 0) {
  $sperre = $thema[0]->sperre;
  $seiten = ceil($anzahlThemen / $BEITRAEGE_SEITE);
  $seite = isset($_GET["seite"]) ? intval($_GET["seite"]) : 1;
  $seite = $seite < 1 || $seite > $seiten ? $seiten : $seite;
  $start = $seite * $BEITRAEGE_SEITE - $BEITRAEGE_SEITE;
  $scriptName = basename($_SERVER["SCRIPT_NAME"]);
?>
<!DOCTYPE html>
<html>
 <head>
  <meta charset="UTF-8">
  <title><?php echo $thema[0]->thema; ?> - Forum</title>
  <link rel="stylesheet" type="text/css" media="screen" href="forum_style.css">
 </head>
<body>

<?php
  include "forum_navigation.php";
  include "forum_funktionen.php";

  // Thema gesperrt
  echo '<p>Thema: <big><b>' . $thema[0]->thema . '</b></big></p>' .
   ($sperre == 1 ? '<p><span class="forum_schloss forum_ko" style="font-weight:normal;"> Das Thema wurde geschlossen, keine weiteren Beiträge möglich!</span></p>' : '');

  // Link-, und Formular-Navigation
  $suche = isset($_GET["suchbegriff"]) && $_GET["suchbegriff"] != '' ? '&suchbegriff=' . $_GET["suchbegriff"] : '';
  define("NAVIGATION", '<form action="' . $scriptName . '" method="get" autocomplete="off"><p class="forum_navseite">' . $anzahlThemen . ($anzahlThemen == 1 ? ' Beitrag' : ' Beiträge') . ' - <label for="site">Seite:</label> ' . 
   (($seite - 1) > 0 ? '<a href="' . $scriptName . '?seite=' . ($seite - 1) . '&thread=' . $thread . $suche . '" title="Zurück zu Seite ' . ($seite - 1) . '"><b>&#9664;</b></a>' : '') .
  ' <input type="text" value="' . $seite . '" name="seite" id="site" size="3" maxlength="4" required="required" onclick="this.select()" title="Seitenzahl eingeben"> von ' . $seiten .
   (($seite + 1) <= $seiten ? ' <a href="' . $scriptName . '?seite=' . ($seite + 1) . '&thread=' . $thread . $suche . '" title="Weiter zu Seite ' . ($seite + 1) . '"><b>&#9654;</b></a>' : '') .
   '<input type="hidden" name="thread" value="' . $thread . '"></p></form>');

  // Navigation
  echo $anzahlThemen > $BEITRAEGE_SEITE ? NAVIGATION : '<p class="forum_navseite">' . $anzahlThemen . ($anzahlThemen == 1 ? ' Beitrag' : ' Beiträge') . '</p>';

  // Beiträge auslesen
  $kommando = $VERBINDUNG->prepare("SELECT `id`, `thread`, `nr`, `name`, `thema`, `text`, `datum`
                                                            FROM `" . $TABLE_PREFIX . "_forum`
                                                            WHERE `thread` = :thread AND  `anzeige` = '1'
                                                            ORDER BY `datum` ASC
                                                            LIMIT "  . $start . ", " . $BEITRAEGE_SEITE);
  $kommando->bindParam(':thread', $thread);
  $kommando->execute();
  $beitraege = $kommando->fetchAll(PDO::FETCH_OBJ);
  $nr = $start;
  foreach ($beitraege as $beitrag) {
   $text = isset($_GET["suchbegriff"]) ? preg_replace('/(' . $_GET["suchbegriff"] . ')/i', "<mark>\$1</mark>", bbcode($beitrag->text)) : bbcode($beitrag->text);
   echo '<dl class="forum_dl">
    <dt><a href="forum_editor.php?id=' . $beitrag->id . '" id="nr' . $beitrag->id . '" class="forum_beitrag"></a><sup><small>' . ($nr+1) . '</small></sup>&nbsp; <b class="forum_profil">' .
    $beitrag->name . '</b> <small>schrieb ' . datetime($beitrag->datum, true) . ($sperre == 0 ? ' - <a href="forum_antwort.php?thread=' . $thread . '&zitat=' . $beitrag->id . '">Zitat</a>' : '') .
    '</small></dt>
    <dd>' . $text . '</dd>
   </dl>';
   $nr++;
  }

  // Navigation
  echo (($nr - $start) >= 8 && $anzahlThemen > $BEITRAEGE_SEITE ? NAVIGATION : '') . '<p class="forum_navigation">';
  if ($sperre == 0) {
   echo '<a href="forum_antwort.php?thread=' . $thread . '" class="forum_qa">Antwort erstellen</a> &emsp;';
  }
  echo '<a href="forum.php" class="forum_start">Startseite</a> &emsp;' .
   (($nr - $start) >= 4  ? '<a href="#top" class="forum_oben">Seitenanfang</a>' : '') . '</p>';
 }
 else {
  echo '<p>&#10008; Dieses Thema ist im Forum nicht vorhanden!<br><br><a href="forum.php">Zum Forum</a></p>';
 }
}
?>

</body>
</html>