<?php
// Session starten
session_start();
?>
<!DOCTYPE html>
<html>
 <head>
  <meta charset="UTF-8">
  <title>Thema erstellen</title>
  <link rel="stylesheet" type="text/css" media="screen" href="forum_style.css">
  <script src="forum_javascript.js"></script>
 </head>
<body>

<?php
/* Forum - forum_frage.php
 - Webbausteine.de */

include "forum_navigation.php";
include "forum_verbindung.php";
include "forum_funktionen.php";

// Admin. überprüfen
$admin = isset($_SESSION["admin"]) ? true : false;

// Formular erstellt mit dem Formular Generator  -
// www.webbausteine.de/blog/tools/formulargenerator.php

// Variablen
$thema = isset($_POST["thema"]) ? strip_tags(trim($_POST["thema"])) : "";
$name = isset($_POST["name"]) ? strip_tags(trim($_POST["name"])) : "";
$text = isset($_POST["text"]) ? trim($_POST["text"]) : "";

// Benutzereingaben überprüfen
$fehler = array("name"=> "", "thema"=> "", "text"=> "", "sicherheit"=>"",);
if (isset($_POST["absenden"]) ||
    isset($_POST["vorschau"])) {
 $fehler["name"] = strlen(trim($_POST["name"])) <= 3 ? "Der Name ist leider zu kurz!" : "";
 $fehler["name"] = strlen(trim($_POST["name"])) == 0 ? "Bitte geben Sie einen Namen ein!" : $fehler["name"];
 $fehler["thema"] = strlen(trim($_POST["thema"])) <= 15 ? "Bitte geben Sie ein Thema ein (mind. 15 Zeichen)!" : "";
 $fehler["text"] = strlen(trim($_POST["text"])) <= 25 ? "Bitte geben Sie einen Beitrag ein (mind. 25 Zeichen)!" : "";
 $fehler["sicherheit"] = ($admin == false && md5($_POST["zip"]) != $_POST["zip2"] && !isset($_POST["vorschau"])) ? "Die Rechenaufgabe ist leider falsch!" : "";
}

// Sicherheitsabfrage - Zufallszahlen generieren
$Z0 = array(mt_rand(1, 9), mt_rand(1, 9));
$Z1 = max($Z0); $Z2 = min($Z0);
$Spam = $Z1 . " &#43; &#" . (48 + $Z2) . ";";
$Schutz = md5($Z1 + $Z2);

// Formular
$formular = "
<form name='Form' action='" . $_SERVER["SCRIPT_NAME"] . "' method='post' enctype='application/x-www-form-urlencoded'>
<fieldset class='forum'>
 <legend class='forum_qa'>Thema erstellen</legend>
<p>
<label>Name:
<input type='text' name='name' value='" . $name . "' id='user' required='required' size='35' maxlength='35' autofocus='autofocus'>
 <span class='forum_pflichtfeld'>&#10034; " . $fehler["name"] . "</span></label><br>
 <span class='forum_hilfetext'>Einen Namen eintragen oder einen Nicknamen (Alias) verwenden.</span>
</p>

<p>
<label>Thema:
 <input type='text' name='thema' value='" . $thema . "' required='required' spellcheck='true' size='60' maxlength='60'>
 <span class='forum_pflichtfeld'>&#10034; " . $fehler["thema"] . "</span></label><br>
 <span class='forum_hilfetext'>Thema eingeben mit max.: 60 Zeichen.</span>
</p>

<p>
 <label for='forum_textarea'>Beitrag:
 <span class='forum_pflichtfeld'>&#10034; " . $fehler["text"] . "</span></label><br>
 <textarea rows='12' cols='65' name='text' id='forum_textarea' required='required'>" . $text . "</textarea><br>
 <span class='forum_hilfetext'>Hier haben Sie viel Raum für ihren Beitrag. Bitte beachten Sie die <a href='forum_regeln.php' target='_blank'>Regeln</a> dieses Forums.</span>
</p>

" . ($admin == false ? "<p>
 <label> Sicherheitsabfrage: &nbsp; 
 <em>" . $Spam . "</em> = 
 <input type='number' name='zip' size='4' autocomplete='off' required='required'>
 <input type='hidden' name='zip2' value='" . $Schutz . "'>
 <span class='forum_pflichtfeld'>&#10034; " . $fehler["sicherheit"] . "</span></label><br>
 <span class='forum_hilfetext'>Bitte lösen Sie die Rechenaufgabe (nicht bei der Vorschau nötig).</span>
</p>" : "") . "

<p style='margin: auto; width: 50%;'>
 <input type='text' name='city' style='display:none;'>
 <input type='submit' name='vorschau' value='Vorschau' formnovalidate='novalidate'> &emsp;
 <input type='button' value='Abbrechen' onDblClick=\"location.href='forum.php'\" title='Zum Abbrechen bitte 2 mal klicken!'> &emsp;
 <input type='submit'  name='absenden' value='Absenden'>
</p>

</fieldset>
</form>
<script>forum_bbcode();</script>
";

// Wurde das Formular abgesendet
if ($_SERVER["REQUEST_METHOD"] == "POST") {
 if (implode("", $fehler) == "" &&
     isset($_POST["absenden"]) &&
     $_POST["city"] == "") {
  // Beitrag eintragen
  $thread = time() . mt_rand(111111111, 999999999);
  $anzeige = $admin == true ? "1" : "0";
  $insert = $VERBINDUNG->prepare("INSERT INTO `" . $TABLE_PREFIX . "_forum`
                                                            SET
                                                               `thread`= '" . $thread . "',
                                                               `fa`= 'F',
                                                               `nr`= '1',
                                                               `anzeige`= :anzeige,
                                                               `name`= :name,
                                                               `thema`= :thema,
                                                               `text`= :text,
                                                               `datum`= NOW()");
  $insert->bindParam(':anzeige', $anzeige);
  $insert->bindParam(':name', $name);
  $insert->bindParam(':thema', $thema);
  $insert->bindParam(':text', $text);
  if ($insert->execute()) {
   $id = $VERBINDUNG->lastInsertId();
   echo '<p><span class="forum_ok">&#10004;</span> Vielen Dank ' . $name . ', dein Beitrag wurde gespeichert';
   if ($admin == false) {
    echo '.<br>Dieser wird vor der Veröffentlichung gelesen, daher kann es etwas dauern bis er erscheint.</p>';

    // E-Mail versenden
    if ($EMAIL_SENDEN == "ja") {
     mb_internal_encoding("UTF-8");
     @mail(
       $ADMIN_EMAIL,
       mb_encode_mimeheader("Forum - Frage [" . $name . "] " . $thema , "UTF-8", "Q"),
       "Datum: " . date("d.m.Y H:i") .
       "\n\nName: " . $name .
       "\n\nThema: " . $thema .
       "\n\n" . $text .
       "\n\nBearbeiten:\n" . $FORUM_PFAD . "/forum_editor.php?id=" . $id . " \n",
       "MIME-Version: 1.0;\nFrom: " . mb_encode_mimeheader("Forum", "UTF-8", "Q") . " <" . $ADMIN_EMAIL . ">" . "\nContent-Type: text/plain; Charset=UTF-8;\n");
    }
   }
   else {
    echo ' und freigeschaltet.</p>';
   }
   // Weiterleitung
   echo "<script>window.setTimeout('location.href=\"forum.php\"', " . $AUTOWEITERLEITUNG . "*1000);</script>
            <noscript><meta http-equiv='refresh' content='" . $AUTOWEITERLEITUNG . "; URL=forum.php'></noscript>
            <p><a href='forum.php' class='forum_start'>Zur Startseite</a></p>";
  }
 }
 else {
  // Vorschau und Formular anzeigen
  if (isset($_POST["vorschau"]) &&
      $text != "") {
   echo '<fieldset class="forum"><legend>Vorschau</legend>'. bbcode($text) . '</fieldset><br>';
  }
  // Formular anzeigen
  echo $formular;
 }
}
else {
 // Formular anzeigen
 echo $formular;
}
?>

</body>
</html>