<?php
/* Forum - forum_funktionen.php
 - Webbausteine.de */

function bbcode($text) {
 $text = htmlspecialchars($text);

 // Smileys
 $smiley = array(
  ":)" => '<img src="laecheln.gif" alt="">',
  ":-)" => '<img src="laecheln.gif" alt="">',
  ":(" => '<img src="traurig.gif" alt="">',
  ":-(" => '<img src="traurig.gif" alt="">',
 );
 $text = strtr($text, $smiley);

 // BB-Code
 $text = preg_replace('/\[quote\](.*?)\[\/quote\]/is', '<blockquote class="forum_blockquote"><b>Zitat:</b><br>$1</blockquote>', $text); // Zitat
 $text = preg_replace('/\[quote\=(.*?)\](.*?)\[\/quote\]/is', '<blockquote class="forum_blockquote"><b>Zitat von $1:</b><br>$2</blockquote>', $text); // Zitat von ...
 $text = preg_replace('/\[b\](.*)\[\/b\]/Usi', '<b>\\1</b>', $text); // [b]
 $text = preg_replace('/\[i\](.*)\[\/i\]/Usi', '<i>\\1</i>', $text); // [i]
 $text = preg_replace('/\[u\](.*)\[\/u\]/Usi', '<u>\\1</u>', $text); // [u]
 $text = preg_replace('/\[code\](.*)\[\/code\]/Usi', '<code class="forum_code">\\1</code>', $text); // [code]
 $text = preg_replace_callback('/\[url=(.*)\](.*)\[\/url\]/Usi', 'linkLenght', $text); // [url]
 return nl2br($text, false);
}

// Links umwandeln
function linkLenght($treffer) {
 $url = trim($treffer[1]);
 if (substr($url, 0 ,7) != 'http://') {
  $url = "http://" . $url;
 }
 if (strlen(trim($treffer[2])) != 0)  {
  $linkname = $treffer[2];
 }
 else {
  $linkname = $treffer[1];
 }

 return '<a href="' . $url . '" rel="nofollow" target="_blank" title="' . $url . '">' . $linkname . '</a>';
}

// Monat ermitteln
function monat($monat) {
 $monate = array(1 => "Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember");
 return $monate[$monat];
}

// Wochentag ermitteln
function wochentag($tag, $monat, $jahr) {
 $tage = array("Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag");
 $wt = getdate(mktime(0, 0, 0, $monat, $tag, $jahr));
 return $tage[$wt["wday"]];
}

// Datum und Uhrzeit
function datetime($datetime, $wt = false) {
 sscanf($datetime, "%4s-%2s-%2s %5s", $jahr, $monat, $tag, $uhr);
 $datum = mktime(0, 0, 0, date($monat), date($tag), date($jahr));
 if ($datum == mktime(0, 0, 0, date("m"), date("d"), date("Y"))) {
  return 'Heute um ' . $uhr . ' Uhr';
 }
 else if ($datum == mktime(0, 0, 0, date("m"), date("d") - 1, date("Y"))) {
  return 'Gestern um ' . $uhr . ' Uhr';
 }
 else if ($datum == mktime(0, 0, 0, date("m"), date("d") - 2, date("Y"))) {
  return 'Vorgestern um ' . $uhr . ' Uhr';
 }
 else {
  if ($wt == false) {
   return 'am ' . floor($tag) . '.' . floor($monat) . '.' . $jahr;
  }
  else {
   return 'am ' . wochentag($tag, $monat, $jahr) . ', den ' . floor($tag) . ' ' . monat($monat) . ' ' . $jahr . ' um ' . $uhr . ' Uhr';
  }
 } 
}

// Neue Beiträge auslesen
function neue_beitraege($VERBINDUNG, $TABLE_PREFIX) {
 $select = $VERBINDUNG->query("SELECT `id`, `fa`, `name`, `thema`, `text`, `datum`
                                                    FROM `" . $TABLE_PREFIX . "_forum`
                                                    WHERE `anzeige` = '0'
                                                    ORDER BY `datum` ASC");
 $beitraege = $select->fetchAll(PDO::FETCH_OBJ);
 $anzahl = count($beitraege);
 if ($anzahl > 0) {
  echo '<p><span class="forum_status">&#10149;</span> Es ' . ($anzahl == 1 ? 'befindet sich <b>1</b> neuer Beitrag' : 'befinden sich <b>' . $anzahl . '</b> neue Beiträge') . ' im Forum.</p>' .
   '<fieldset class="forum"><legend>Beiträge</legend>';
  foreach ($beitraege as $nr => $beitrag) {
   echo '<dl class="forum_dl">
    <dt><a href="forum_editor.php?id=' . $beitrag->id . '" class="forum_beitrag"></a><sup><small>' . ($nr+1) . '</small></sup>&nbsp; <b>' .
    $beitrag->name . '</b> <small>schrieb eine ' . ($beitrag->fa == "F" ? 'Frage, ' : 'Antwort, ') . datetime($beitrag->datum, true) .
    ' zum Thema: ' . $beitrag->thema . '</small></dt>
    <dd>' . bbcode($beitrag->text) . '</dd>
   </dl>';
  }
  echo '</fieldset>';
 }
 else {
  echo '<p><span class="forum_status">&#10149;</span> Es befinden sich keine neuen Beiträge im Forum.</p>';
 }
}
?>