/*  Forum - JavaScript-Funktionen - forum_javascript.js
 - Webbausteine.de */

function forum_bbcode() {
 // BB-Code Script von: J. Strübig
 var url = new RegExp('^(http://|https://|www.|ftp://|mailto:)');
 var findLink = function(tag, text, button) {
  var new_text = text;
  if ( url.test(text) ) {
   href = text;
   new_text = window.prompt('Linktext eingeben:', '');
   if (new_text == null) return text;
   if (!new_text) new_text = text;
  }
  else {
   new_text = text || window.prompt('Linktext eingeben:', '');
   if (new_text == null) return text;
   var href = window.prompt('URL eingeben:', 'http://');
   if (href == 'http://' || href == null)return text;
   if (!url.test(href)) href = 'http://' + href;
  }
  return this.def('url', new_text, button, '=' + href);
 };

 function s1() {return " :) ";}
 function s2() {return " :( ";}

 var param =  {
  element: document.getElementById("forum_textarea"),
  buttons: [
   {tag: ':)', func: s1, help:"Smiley einfügen"},
   {tag: ':(', func: s2, help:"Smiley einfügen"},
   '-',
   {tag: 'b', help:"Fettschrift einfügen\n[b] Text [/b]"},
   {tag: 'u', help:"Unterstrichen einfügen\n[u] Text [/u]"},
   {tag: 'i', help:"Kursivschrift einfügen\n[i] Text [/i]"},
   '-',
   {tag: 'quote', help:"Zitat einfügen\n[quote] Text [/quote]\n[quote=Name] Text [/quote]"},
   {tag: 'code', help:"Quelltext einfügen\n[code] Quelltext [/code]"},
   {tag: 'link', func: findLink, help:"Link einfügen ..."}
  ]
 };

 BB_Code(param);
}

function BB_Code(p) {
 if (
  !p ||
  typeof p != 'object' ||
  !p.element ||
  !p.buttons ||
  !document.createElement
 ) return;

 var textarea = p.element;
 var br = document.createElement("br");
 var nbsp = '\xA0';
 textarea.parentNode.insertBefore(br, textarea);
 var prev, obj;
 for(var i = 0; i < p.buttons.length; i++) {
   var tmp = p.buttons[i];
   if (typeof tmp == 'object') {
    obj = createButton(tmp);
    if (tmp.func) BB_Code.TagList[tmp.tag] = tmp.func;
   }
   if (tmp == '-' && prev) prev.style.marginRight = BB_Code.margin;
   prev = obj;
 }

 textarea.onblur = function() {
  if (typeof this.selectionStart != 'undefined') {
    this.start = this.selectionStart;
    this.end = this.selectionEnd;
  };
 };

 function createButton(obj) {
  if (!obj.text) obj.text = obj.tag;
  var button = document.createElement('input');
  button.type = 'button';
  button.className = 'bb_button';
  button.value = obj.text;
  button.onclick = function() {
   insertTag(obj.tag, this);
   return false;
  };

  br.parentNode.insertBefore(button, br);
  if (obj.help) button.title = obj.help;
  return button;
 }

 function insertTag(tag, button) {
  if (!textarea) return false;
  textarea.focus();
  function getSelection() {
   if (typeof document.selection != 'undefined') {
    var range = document.selection.createRange();
    return range.text;
   }
   else if (typeof textarea.selectionStart != 'undefined') {
    var start = textarea.selectionStart;
    var end = textarea.selectionEnd;
    return textarea.value.substring(start, end);
   }
   return window.prompt('Textinput:');
  }

  function insertText(t) {
   if (typeof document.selection != 'undefined') {
    var range = document.selection.createRange();
    range.text = t;
    if (t.length == 0) range.move('character', -1);
    else range.moveStart('character', t.length);
   }
   else if (typeof textarea.selectionStart != 'undefined') {
    var scrollPos = textarea.scrollTop;
    var start = textarea.start || textarea.selectionStart;
    var end = textarea.end || textarea.selectionEnd;
    textarea.value = textarea.value.substr(0, start) + t + textarea.value.substr(end);
    var pos = start + t.length;
    textarea.selectionStart = pos;
    textarea.selectionEnd = pos;
    textarea.scrollTop = scrollPos;
   }
   else {
    textarea.value += t;
   }
  }
  var t = getSelection();
  var tag_func = typeof BB_Code.TagList[tag] == 'function' ? tag : 'def';
  var new_text = BB_Code.TagList[tag_func](tag, t, button);
  insertText(new_text);
  return !!t;
 }

}
BB_Code.TagList = {
 def: function(tag, text, button, attr) {
  var start = '[' + tag + (attr || '') + ']';
  var end = '[/' + tag + ']';
  var slash = '/';
  if (text) return start + text + end;
  button.value = button.value.indexOf(slash) > -1 ? 
  button.value.substr(1) : slash + button.value;
  return button.value.indexOf(slash) > -1 ? start : end;
 }
};
BB_Code.margin = '0.9em';


function hinweis() {
 var txt;
 switch (document.Form.sperre.options[document.Form.sperre.selectedIndex].value) {
  case "":
   txt = "";
   break;
  case "0":
   txt = '<span style="color:blue">Neue Beiträge können eingetragen werden.</span>';
   break;
  case "1":
   txt = '<span style="color:red">Neue Beiträge können nicht eingetragen werden.</span>';
   break;
  case "2":
   txt = '<span style="color:red">Thema und alle Beiträge darin komplett löschen!</span>';
   break;
 }
 document.getElementById("hinweis").innerHTML = txt;
}