<?php
// Session starten
session_start();
?>
<!DOCTYPE html>
<html>
 <head>
  <meta charset="UTF-8">
  <title>Suche</title>
  <link rel="stylesheet" type="text/css" media="screen" href="forum_style.css">
 </head>
<body>

<?php include "forum_navigation.php";?>

<?php
/* Forum - Suche - forum_suche.php
 - Webbausteine.de */

include "forum_verbindung.php";
include "forum_funktionen.php";

// Formular
echo '<form action="" method="get"> 
<p>Im Forum suchen nach: <i>Thema</i>, <i>Beitrag</i> oder <i>Name</i>.</p>
<input type="search" name="suchbegriff" size="30" min="4" maxlength="50"' . (isset($_GET['suchbegriff']) ? ' value="' . $_GET['suchbegriff'] . '"' : '') . ' required="required" placeholder="Suchbegriff eingeben">
<input type="submit" name="suchen" value="suchen">
</form>';

// Formular abgesendet
if (isset($_GET["suchen"])) {
 $suchbegriff = strip_tags(trim($_GET["suchbegriff"]));
 if (strlen($suchbegriff) >= 4) {
  // Die Anzahl der Treffer des Suchbegriffs ermitteln
  $kommando = $VERBINDUNG->prepare("SELECT `id`
                                                            FROM `" . $TABLE_PREFIX . "_forum`
                                                            WHERE (`name` LIKE :suchbegriff OR
                                                                         `thema` LIKE :suchbegriff OR
                                                                         `text` LIKE :suchbegriff) AND `anzeige` = '1'");
  $like = "%" . $suchbegriff . "%";
  $kommando->bindParam(':suchbegriff', $like);
  $kommando->execute();
  $anzahlBeitraege = count($kommando->fetchAll());

  // Gefundene Beiträge anzeigen
  if ($anzahlBeitraege > 0) {
   echo '<p><span class="forum_ok">&#10004;</span> Es ' . ($anzahlBeitraege == 1 ? 'wurde 1 Beitrag' : 'wurden ' . $anzahlBeitraege . ' Beiträge') . ' gefunden.</p>';
   // Gefundene Beiträge auslesen
   $seite = isset($_GET["seite"]) ? intval($_GET["seite"]) : 1;
   $start = $seite * $BEITRAEGE_SEITE - $BEITRAEGE_SEITE;
   $select = $VERBINDUNG->prepare("SELECT `id`, `thread`, `thema`, `name`, `datum`
                                                             FROM `" . $TABLE_PREFIX . "_forum`
                                                             WHERE (`name` LIKE :suchbegriff OR 
                                                                          `thema` LIKE :suchbegriff OR 
                                                                          `text` LIKE :suchbegriff) AND `anzeige` = '1'
                                                          ORDER BY `datum` DESC
                                                          LIMIT "  . $start . ", " . $BEITRAEGE_SEITE);
   $select->bindParam(':suchbegriff', $like);
   $select->execute();
   $beitraege = $select->fetchAll(PDO::FETCH_OBJ);

   // Beiträge ausgeben
   echo '<ol start="' . ($start+1) . '" class="forum_ol">';
   foreach ($beitraege as $beitrag) {
     sscanf($beitrag->datum, "%4s-%2s-%2s %5s", $jahr, $monat, $tag, $uhr);
    echo '<li><a href="forum_details.php?thread=' . $beitrag->thread . '&suchbegriff=' . $suchbegriff . '">' .
     $beitrag->thema . '</a> <small>- ' . $beitrag->name . ' - ' . $tag . '.' . $monat . '.' . $jahr . ' - ' . $uhr . ' Uhr</small></li>';
   }
   echo '</ol>';
  $seiten = ceil($anzahlBeitraege / $BEITRAEGE_SEITE);
  $seite = $seite < 1 || $seite > $seiten ? 1 : $seite;

  // Link-, und Formular-Navigation
  $scriptName = basename($_SERVER["SCRIPT_NAME"]);
  define("NAVIGATION", '<form action="' . $scriptName . '" method="get" autocomplete="off"><p><label for="site">Seite:</label> ' . 
   (($seite - 1) > 0 ? '<a href="' . $scriptName . '?seite=' . ($seite - 1) . '&suchbegriff=' . $suchbegriff . '&suchen" title="Zurück zu Seite ' . ($seite - 1) . '"><b>&#9664;</b></a>' : '') .
   ' <input type="text" value="' . $seite . '" name="seite" id="site" size="3" maxlength="4" required="required" onclick="this.select()" title="Seitenzahl eingeben"> von ' . $seiten .
   (($seite + 1) <= $seiten ? ' <a href="' . $scriptName . '?seite=' . ($seite + 1) . '&suchbegriff=' . $suchbegriff . '&suchen" title="Weiter zu Seite ' . ($seite + 1) . '"><b>&#9654;</b></a>' : '') .
   '<input type="hidden" name="suchbegriff" value="' . $suchbegriff . '"><input type="hidden" name="suchen" value="suchen"></p></form>');
  echo $anzahlBeitraege > $BEITRAEGE_SEITE ? NAVIGATION : '';
  }
  else {
   echo '<p><span class="forum_ko">&#10008;</span> Es wurden keine Beiträge gefunden!</p>';
  }
 }
 else {
  echo '<p><span class="forum_ko">&#10008;</span> Es sind min. 4 Zeichen nötig!</p>';
 }
}
else {

 // Beiträge - Hits
 $kommando = $VERBINDUNG->query("SELECT `thread`, `nr`, `thema`
                                                        FROM `" . $TABLE_PREFIX . "_forum`
                                                        WHERE `fa` = 'F' AND `anzeige` = '1'
                                                        ORDER BY `nr` DESC
                                                       LIMIT 10");
 $themen = $kommando->fetchAll(PDO::FETCH_OBJ);
 if (count($themen) > 0) {
  echo '<p style="margin-top: 40px;">Themen mit den meisten Beiträgen</p>' .
   '<table class="forum_table">';
  foreach ($themen as $thema) {
   echo '<tr><th>' . $thema->nr . '</th><td><a href="forum_details.php?thread=' . $thema->thread . '" class="forum_beitrag">' . $thema->thema . '</a></td></tr>';
  }
  echo '</table>';
 }
}
?>

</body>
</html>